accounts/urls.py
from django.contrib.auth import views
from django.urls import path

from .views import (
    ArticleListView, 
    ArticleCreateView, 
    ArticleUpdateView, 
    ArticleDeleteView, 
    UserProfileEditView,
)

app_name = 'accounts'

urlpatterns = [
    path('', ArticleListView.as_view(), name='article_list'),
    path('articles/create/', ArticleCreateView.as_view(), name='article_create'),
    path('articles/update/<int:pk>/', ArticleUpdateView.as_view(), name='article_update'),
    path('articles/delete/<int:pk>/', ArticleDeleteView.as_view(), name='article_delete'),
    path('profile/edit/', UserProfileEditView.as_view(), name='user_profile_edit'),
    
]

blog/urls.py
from django.urls import path
from .views import ArticleListView, ArticleDetailView, CategoryListView, AuthorListView, ArticlePreviewView

app_name = 'blog'

urlpatterns = [
	path('', ArticleListView.as_view(), name='home'),
	path('page/<int:page>', ArticleListView.as_view(), name='home'),
	path('article/<slug:slug>', ArticleDetailView.as_view(), name='post_detail'),
	path('preview/<int:pk>', ArticlePreviewView.as_view(), name='post_preview'),
	path('category/<slug:slug>', CategoryListView.as_view(), name='category_posts'),
	path('category/<slug:slug>/page/<int:page>', CategoryListView.as_view(), name='category_posts'),
	path('author/<slug:username>', AuthorListView.as_view(), name='author_posts'),
	path('author/<slug:username>/page/<int:page>', AuthorListView.as_view(), name='author_posts'),
]

core/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.contrib.auth.views import PasswordChangeView, PasswordChangeDoneView
from django.urls import path, include, re_path

from accounts.views import Login, SignUpView, activate_account

urlpatterns = [
	path('', include('blog.urls')),
	path('', include('django.contrib.auth.urls')),
	path('login/', Login.as_view(), name='login'),
	path('signup/', SignUpView.as_view(), name='signup'),
	path('activate/<slug:uidb64>/<slug:token>/',activate_account, name='activate_account'),
	path('admin/', admin.site.urls),
	path('accounts/', include('accounts.urls')),
	path('accounts/profile/password_change/', PasswordChangeView.as_view(), name='password_change'),
	path('accounts/profile/password_change/done/', PasswordChangeDoneView.as_view(), name='password_change_done'),

	
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

blog/models.py
from django.db import models
from django.urls import reverse
from django.utils.html import format_html
from django.utils import timezone

from accounts.models import User
from extensions.utils import jalali_convertor

STATUS_CHOICES = (
    ('d', 'پیش نویس'),
    ('p', 'منتشر شده'),
    ('w', 'در انتظار تایید'),
    ('b', 'برگشت داده شده'),
)

# Custom Managers
class ArticleManager(models.Manager):
    def published(self):
        return self.filter(status='p')

class CategoryManager(models.Manager):
    def active(self):
        return self.filter(status=True)

# Models
class Category(models.Model):
    title = models.CharField(max_length=200, verbose_name='عنوان دسته‌بندی')
    slug = models.SlugField(max_length=100, unique=True, verbose_name='آدرس')
    parent = models.ForeignKey('self', default=None, null=True, blank=True, on_delete=models.SET_NULL, related_name='children', verbose_name='زیردسته')
    status = models.BooleanField(default=True, verbose_name='آیا نمایش داده شود؟',)
    position = models.IntegerField(verbose_name='پوزیشن')

    class Meta:
        verbose_name = 'دسته‌بندی'
        verbose_name_plural = 'دسته‌بندی‌ها'
        ordering = ['parent__id','position']

    def __str__(self):
        return self.title

    objects = CategoryManager()

class Article(models.Model):
    author = models.ForeignKey(User, null=True, on_delete=models.SET_NULL, related_name='articles', verbose_name='نویسنده')
    title = models.CharField(max_length=200, verbose_name='عنوان')
    slug = models.SlugField(max_length=100, unique=True, verbose_name='آدرس')
    category = models.ManyToManyField(Category, verbose_name='دسته‌بندی', related_name='articles')
    description = models.TextField(verbose_name='محتوا')
    thumbnail = models.ImageField(upload_to='images', verbose_name='تصویر')
    created_on = models.DateTimeField(auto_now_add=True, verbose_name = 'ایجاد شده در')
    published_on = models.DateTimeField(default=timezone.now, verbose_name = 'منتشر شده در')
    updated_on = models.DateTimeField(auto_now=True, verbose_name = 'آپدیت شده در')
    is_special = models.BooleanField(default=False, verbose_name='مقاله ویژه',)
    status = models.CharField(max_length=1, choices=STATUS_CHOICES, verbose_name='وضعیت',)

    class Meta:
        verbose_name = 'مقاله'
        verbose_name_plural = 'مقالات'
        ordering = ['-published_on']

    def __str__(self):
        return self.title

    def get_absolute_url(self):
        return reverse('accounts:article_list')

    def jpublish(self):
        return jalali_convertor(self.published_on)
    jpublish.short_description = 'منتشر شده در'

    def jcreate(self):
        return jalali_convertor(self.created_on)
    jcreate.short_description = 'ایجاد شده در'

    def jupdate(self):
        return jalali_convertor(self.updated_on)
    jupdate.short_description = 'آپدیت شده در'

    def thumbnail_tag(self):
        return format_html(f'<img src="{self.thumbnail.url}" width=120 height=95 style="border-radius:5px;">')
    thumbnail_tag.short_description = 'تصویر'

    def cat_to_str(self):
        return '، '.join([category.title for category in self.category.active()])
    cat_to_str.short_description = 'دسته‌بندی(ها)'

    objects = ArticleManager()
    
    

blog/views.py
from django.views.generic import ListView, DetailView
from django.core.paginator import Paginator
from django.shortcuts import render, get_object_or_404
# from django.http import HttpResponse, JsonResponse
from .models import Article, Category
from accounts.models import User
from accounts.mixins import AuthorAccessMixin

# Create your views here.
# def home(request, page=1):
#     articles_list = Article.objects.published()
#     paginator = Paginator(articles_list, 5)
#     articles = paginator.get_page(page)
#     context = {
#         'articles': articles,
#     }
#     return render(request, 'blog/home.html', context)

class ArticleListView(ListView):
    # model = Article
    # template_name = "blog/home.html"
    # context_object_name = 'articles'
    queryset = Article.objects.published()
    paginate_by = 5


# def post_detail(request, slug):
#     article = get_object_or_404(Article.objects.published(), slug=slug)
#     context = {
#         'article': article
#     }
#     return render(request, 'blog/post_detail.html', context)

class ArticleDetailView(DetailView):
    def get_object(self):
        slug = self.kwargs.get('slug')
        return get_object_or_404(Article.objects.published(), slug=slug)

class ArticlePreviewView(AuthorAccessMixin, DetailView):
    def get_object(self):
        pk = self.kwargs.get('pk')
        return get_object_or_404(Article, pk=pk)


# def category_posts(request, slug, page=1):
#     category = get_object_or_404(Category, slug=slug, status=True)
#     articles_list = category.articles.published()
#     paginator = Paginator(articles_list, 5)
#     articles = paginator.get_page(page)
#     context = {
#         'category': category,
#         'articles': articles
#     }
#     return render(request, 'blog/category_posts.html', context)

class CategoryListView(ListView):
    paginate_by = 5
    template_name = 'blog/category_list.html'

    def get_queryset(self):
        global category
        slug = self.kwargs.get('slug')
        category = get_object_or_404(Category.objects.active(), slug=slug)
        return category.articles.published()

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["category"] = category
        return context

class AuthorListView(ListView):
    paginate_by = 5
    template_name = 'blog/author_list.html'

    def get_queryset(self):
        global author
        username = self.kwargs.get('username')
        author = get_object_or_404(User, username=username)
        return author.articles.published()

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["author"] = author
        return context
    

templates/blog/about.html
{% extends 'blog/base.html' %}

{% block content %}
  <!-- Main Content -->
  <div class="container">
    <div class="row">
      <div class="col-lg-8 col-md-10 mx-auto">
        <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Saepe nostrum ullam eveniet pariatur voluptates odit, fuga atque ea nobis sit soluta odio, adipisci quas excepturi maxime quae totam ducimus consectetur?</p>
        <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Eius praesentium recusandae illo eaque architecto error, repellendus iusto reprehenderit, doloribus, minus sunt. Numquam at quae voluptatum in officia voluptas voluptatibus, minus!</p>
        <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Aut consequuntur magnam, excepturi aliquid ex itaque esse est vero natus quae optio aperiam soluta voluptatibus corporis atque iste neque sit tempora!</p>
      </div>
    </div>
  </div>
{% endblock content %}
  

templates/blog/article_detail.html
{% extends 'blog/base.html' %}

{% block title %}| {{ object.title }}{% endblock title %}
	
{% block content %}

	<!-- Page Header -->
	<header class="masthead" style="background-image: url('{{ object.thumbnail.url }}')">
		<div class="overlay"></div>
		<div class="container">
			<div class="row">
				<div class="col-lg-8 col-md-10 mx-auto">
					<div class="site-heading">
						<h1 class="myfont">
							{{ object.title }}
							{% if article.is_special %}
								<span class="badge badge-danger" style="font-size: 16px;">ویژه</span>
							{% endif %}
						</h1>
						<time>{{ object.jpublish }}</time>
					</div>
				</div>
			</div>
		</div>
	</header>

	<article>
		<div class="container">
			<div class="row">
				<div class="col-lg-8 col-md-10 mx-auto text-justify myfont">
					
					{% if object.is_special %}
						
						{% if user.is_authenticated and user.is_vip_user or user == object.author or user.is_superuser %}
							{{ object.description|safe }}
						{% else %}
							{{ article.description|striptags|truncatewords:30 }}
							<p></p>
							<h4 class="alert alert-warning myfont text-center px-3">
								این یک مقاله ویژه هست.<br>
								برای مشاهده ادامه آن به اکانت ویژه خود <a href="{% url 'accounts:login' %}">وارد شوید</a> یا <a href="#">اشتراک ویژه بخرید</a>
							</h4>
						{% endif %}
							
					{% else %}
						{{ object.description|safe }}
					{% endif %}
						
				</div>
			</div>
		</div>
	</article>
{% endblock content %}
	

templates/blog/article_list.html
{% extends 'blog/list.html' %}

{% block title %}| صفحه اصلی{% endblock title %}

{% block previous_page_url %}
      {% url 'blog:home' page_obj.previous_page_number %}
{% endblock previous_page_url %}
      
{% block next_page_url %}
      {% url 'blog:home' page_obj.next_page_number %}         
{% endblock next_page_url %}
      
            
          

templates/blog/author_list.html
{% extends 'blog/list.html' %}

{% block title %}| نویسنده {{ author.get_full_name }}{% endblock title %}

{% block top_title %}
    <h3 class="alert alert-primary text-center">نویسنده: {{ author.get_full_name }}</h3>  
{% endblock top_title %}

{% block previous_page_url %}
    {% url 'blog:author_posts' author.username page_obj.previous_page_number %}          
{% endblock previous_page_url %}

{% block next_page_url %}
    {% url 'blog:author_posts' author.username page_obj.next_page_number %}           
{% endblock next_page_url %}

templates/blog/base.html
{% load static %}
{% load base_tags %}
<!DOCTYPE html>
<html lang="en">

<head>

  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <meta name="description" content="">
  <meta name="author" content="">

  <title>بلاگفا {% block title %}{% endblock title %}</title>
  
  <!-- Bootstrap core CSS -->
  <link href="{% static 'blog/vendor/bootstrap/css/bootstrap.min.css' %}" rel="stylesheet">
  
  
  <!-- Custom fonts for this template -->
  <link href="{% static 'blog/vendor/fontawesome-free/css/all.min.css' %}" rel="stylesheet" type="text/css">
  <link href='https://fonts.googleapis.com/css?family=Lora:400,700,400italic,700italic' rel='stylesheet' type='text/css'>
  <link href='https://fonts.googleapis.com/css?family=Open+Sans:300italic,400italic,600italic,700italic,800italic,400,300,600,700,800' rel='stylesheet' type='text/css'>
  
  <!-- Custom styles for this template -->
  <link href="{% static 'blog/css/clean-blog.min.css' %}" rel="stylesheet">
  <link href="{% static 'blog/css/rtl.css' %}" rel="stylesheet">
  
  {% block custom_head %}
    
  {% endblock custom_head %}
    
</head>

<body>

  <!-- Navigation -->
  <nav class="navbar navbar-expand-lg navbar-light fixed-top" id="mainNav">
    <div class="container">
      <a class="navbar-brand myfont" href="{% url 'blog:home' %}">{% title %}</a>
      <button class="navbar-toggler navbar-toggler-right" type="button" data-toggle="collapse" data-target="#navbarResponsive" aria-controls="navbarResponsive" aria-expanded="false" aria-label="Toggle navigation">
        منو
        <i class="fas fa-bars"></i>
      </button>
      {% category_navbar %}
    </div>
  </nav>

  {% block content %}
      
  {% endblock content %}

  <hr>

  <!-- Footer -->
  <footer>
    <div class="container">
      <div class="row">
        <div class="col-lg-8 col-md-10 mx-auto">
          <ul class="list-inline text-center">
            <li class="list-inline-item">
              <a href="#">
                <span class="fa-stack fa-lg">
                  <i class="fas fa-circle fa-stack-2x"></i>
                  <i class="fab fa-twitter fa-stack-1x fa-inverse"></i>
                </span>
              </a>
            </li>
            <li class="list-inline-item">
              <a href="#">
                <span class="fa-stack fa-lg">
                  <i class="fas fa-circle fa-stack-2x"></i>
                  <i class="fab fa-facebook-f fa-stack-1x fa-inverse"></i>
                </span>
              </a>
            </li>
            <li class="list-inline-item">
              <a href="#">
                <span class="fa-stack fa-lg">
                  <i class="fas fa-circle fa-stack-2x"></i>
                  <i class="fab fa-github fa-stack-1x fa-inverse"></i>
                </span>
              </a>
            </li>
          </ul>
          <p class="copyright text-muted">Copyright &copy; Your Website 2020</p>
        </div>
      </div>
    </div>
  </footer>

  <!-- Bootstrap core JavaScript -->
  <script src="{% static 'blog/vendor/jquery/jquery.min.js' %}"></script>
  <script src="{% static 'blog/vendor/bootstrap/js/bootstrap.bundle.min.js' %}"></script>

  <!-- Custom scripts for this template -->
  <script src="{% static 'blog/js/clean-blog.min.js' %}"></script>

</body>

</html>

templates/blog/category_list.html
{% extends 'blog/list.html' %}

{% block title %}| دسته‌بندی {{ category.title }}{% endblock title %}

{% block top_title %}
    <h3 class="alert alert-primary text-center">دسته‌بندی: {{ category.title }}</h3>  
{% endblock top_title %}

{% block previous_page_url %}
    {% url 'blog:category_posts' category.slug page_obj.previous_page_number %}          
{% endblock previous_page_url %}

{% block next_page_url %}
    {% url 'blog:category_posts' category.slug page_obj.next_page_number %}           
{% endblock next_page_url %}

templates/blog/contact.html
{% extends 'blog/base.html' %}

{% block content %}
  <!-- Main Content -->
  <div class="container">
    <div class="row">
      <div class="col-lg-8 col-md-10 mx-auto">
        <p>Want to get in touch? Fill out the form below to send me a message and I will get back to you as soon as possible!</p>
        <!-- Contact Form - Enter your email address on line 19 of the mail/contact_me.php file to make this form work. -->
        <!-- WARNING: Some web hosts do not allow emails to be sent through forms to common mail hosts like Gmail or Yahoo. It's recommended that you use a private domain email address! -->
        <!-- To use the contact form, your site must be on a live web host with PHP! The form will not work locally! -->
        <form name="sentMessage" id="contactForm" novalidate>
          <div class="control-group">
            <div class="form-group floating-label-form-group controls">
              <label>Name</label>
              <input type="text" class="form-control" placeholder="Name" id="name" required data-validation-required-message="Please enter your name.">
              <p class="help-block text-danger"></p>
            </div>
          </div>
          <div class="control-group">
            <div class="form-group floating-label-form-group controls">
              <label>Email Address</label>
              <input type="email" class="form-control" placeholder="Email Address" id="email" required data-validation-required-message="Please enter your email address.">
              <p class="help-block text-danger"></p>
            </div>
          </div>
          <div class="control-group">
            <div class="form-group col-xs-12 floating-label-form-group controls">
              <label>Phone Number</label>
              <input type="tel" class="form-control" placeholder="Phone Number" id="phone" required data-validation-required-message="Please enter your phone number.">
              <p class="help-block text-danger"></p>
            </div>
          </div>
          <div class="control-group">
            <div class="form-group floating-label-form-group controls">
              <label>Message</label>
              <textarea rows="5" class="form-control" placeholder="Message" id="message" required data-validation-required-message="Please enter a message."></textarea>
              <p class="help-block text-danger"></p>
            </div>
          </div>
          <br>
          <div id="success"></div>
          <button type="submit" class="btn btn-primary" id="sendMessageButton">Send</button>
        </form>
      </div>
    </div>
  </div>
{% endblock content %}
  

templates/blog/list.html
{% extends 'blog/base.html' %}

{% load static %}

{% block content %}

  <!-- Page Header -->
  <header class="masthead" style="background-image: url('{% static "blog/img/home-bg.jpg" %}')">
    <div class="overlay"></div>
    <div class="container">
      <div class="row">
        <div class="col-lg-8 col-md-10 mx-auto">
          <div class="site-heading myfont">
            <h1 class="myfont">بلاگفا</h1>
            <span class="subheading myfont">بهترین وبلاگ دنیا</span>
          </div>
        </div>
      </div>
    </div>
  </header>

  <!-- Main Content -->
  <div class="container myfont">
    <div class="row">
      <div class="col-lg-8 col-md-10 mx-auto">
        
        {% block top_title %}
          
        {% endblock top_title %}

        {% for article in object_list %}
          <div class="post-preview">
            <a href="{% url 'blog:post_detail' article.slug %}">
              <h2 class="post-title myfont">
                {{ article.title }}
                
                {% if article.is_special %}
                  <span class="badge badge-danger" style="font-size: 16px;">ویژه</span>
                {% endif %}
                  
              </h2>
              <h3 class="post-subtitle myfont">
                {{ article.description|striptags|truncatewords:30 }}
              </h3>
            </a>
            <p class="post-meta">نوشته شده توسط
              <a href="{% url 'blog:author_posts' article.author %}">{{ article.author.get_full_name }}</a>
              در {{ article.jpublish }}</p>
            <div>
              
              {% for category in article.category.active %}
                <a href="{% url 'blog:category_posts' category.slug %}">#{{ category.title }}</a>
              {% endfor %}
                
            </div>
          </div>
          <hr>
        {% endfor %}
          
        <!-- Pager -->
        <div class="clearfix">

          {% if is_paginated %}
            {% if page_obj.has_previous %}
              <a class="btn btn-primary float-right myfont" href="{% block previous_page_url %}{% endblock previous_page_url %}">&rarr; پست‌های جدید</a>
            {% endif %}
            {% if page_obj.has_next %}
              <a class="btn btn-primary float-left myfont" href="{% block next_page_url %}{% endblock next_page_url %}">پست‌های قدیمی &larr;</a>
            {% endif %}
          {% endif %}

        </div>
      </div>
    </div>
  </div>
{% endblock content %}